diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.39/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.38/src/wifi/test/spectrum-wifi-phy-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/spectrum-wifi-phy-test.cc	2023-07-05 14:23:48.125428400 -0700
@@ -728,6 +816,686 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief Spectrum Wifi Phy Multiple Spectrum Test
+ *
+ * This test is testing the ability to plug multiple spectrum channels to the spectrum wifi PHY.
+ * It considers 4 TX-RX PHY pairs that are independent from each others and are plugged to different
+ * spectrum channels that are covering different frequency range. Each RX PHY is also attached to
+ * each of the other 3 spectrum channels it can switch to.
+ *
+ * In the first scenario, we consider the default case where each TX-RX PHY pairs are operating on
+ * different frequency ranges and hence using independent spectrum channels. We validate that no
+ * packets is received from other TX PHYs attached to different spectrum channels and we also verify
+ * the amount of connected PHYs to each spectrum channel is exactly 2. The test also makes sure each
+ * PHY has only one active spectrum channel and that the active one is operating at the expected
+ * frequency range.
+ *
+ * In the second scenario, we consecutively switch the channel of all RX PHYs to the one of each TX
+ * PHY. We validate that packets are received by all PHYs and we also verify the amount of connected
+ * PHYs to each spectrum channels is either 5 (1 TX PHY and 4 RX PHYs) or 1 (the TX PHY left alone).
+ */
+class SpectrumWifiPhyMultipleInterfacesTest : public TestCase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * \param trackSignalsInactiveInterfaces flag to indicate whether signals coming from inactive
+     * spectrum PHY interfaces shall be tracked during the test
+     */
+    SpectrumWifiPhyMultipleInterfacesTest(bool trackSignalsInactiveInterfaces);
+
+  private:
+    void DoSetup() override;
+    void DoTeardown() override;
+    void DoRun() override;
+
+    /**
+     * Switch channel function
+     *
+     * \param index the index to identify the RX PHY
+     * \param band the PHY band to use
+     * \param channelNumber number the channel number to use
+     * \param channelWidth the channel width to use
+     */
+    void SwitchChannel(std::size_t index,
+                       WifiPhyBand band,
+                       uint8_t channelNumber,
+                       uint16_t channelWidth);
+
+    /**
+     * Send PPDU function
+     *
+     * \param phy the PHY to transmit the signal
+     * \param txPowerDbm the power in dBm to transmit the signal (this is also the received power
+     * since we do not have propagation loss to simplify)
+     */
+    void SendPpdu(Ptr<SpectrumWifiPhy> phy, double txPowerDbm);
+
+    /**
+     * Callback triggered when a packet is received by a PHY
+     * \param index the index to identify the RX PHY
+     * \param packet the received packet
+     * \param rxPowersW the received power per channel band in watts
+     */
+    void RxCallback(std::size_t index,
+                    Ptr<const Packet> packet,
+                    RxPowerWattPerChannelBand rxPowersW);
+
+    /**
+     * Schedule now to check the interferences
+     * \param phy the PHY for which the check has to be executed
+     * \param freqRange the frequency range for which the check has to be executed
+     * \param channelWidth the channel width for which the check has to be executed
+     * \param interferencesExpected flag whether interferences are expected to have been tracked
+     */
+    void CheckInterferences(Ptr<ExtSpectrumWifiPhy> phy,
+                            const FrequencyRange& freqRange,
+                            uint16_t channelWidth,
+                            bool interferencesExpected);
+
+    /**
+     * Check the interferences
+     * \param phy the PHY for which the check has to be executed
+     * \param freqRange the frequency range for which the check has to be executed
+     * \param channelWidth the channel width for which the check has to be executed
+     * \param interferencesExpected flag whether interferences are expected to have been tracked
+     */
+    void DoCheckInterferences(Ptr<ExtSpectrumWifiPhy> phy,
+                              const FrequencyRange& freqRange,
+                              uint16_t channelWidth,
+                              bool interferencesExpected);
+
+    /**
+     * Verify results
+     *
+     * \param index the index to identify the RX PHY to check
+     * \param expectedNumRx the expected number of RX events for that PHY
+     * \param expectedFrequencyRangeActiveRfInterface the expected frequency range (in MHz) of the
+     * active RF interface
+     * \param expectedConnectedPhysPerChannel the expected
+     * number of PHYs attached for each spectrum channel
+     */
+    void CheckResults(std::size_t index,
+                      uint32_t expectedNumRx,
+                      FrequencyRange expectedFrequencyRangeActiveRfInterface,
+                      const std::vector<std::size_t>& expectedConnectedPhysPerChannel);
+
+    /**
+     * Verify CCA indication reported by a given PHY
+     *
+     * \param index the index to identify the RX PHY to check
+     * \param expectedCcaBusyIndication flag to indicate whether a CCA BUSY notification is expected
+     * \param switchingDelay delay between the TX has started and the time RX switched to the TX
+     * channel
+     */
+    void CheckCcaIndication(std::size_t index, bool expectedCcaBusyIndication, Time switchingDelay);
+
+    /**
+     * Reset function
+     */
+    void Reset();
+
+    /// typedef for spectrum channel infos
+    using SpectrumChannelInfos = std::tuple<Ptr<MultiModelSpectrumChannel>, uint16_t, uint16_t>;
+
+    bool
+        m_trackSignalsInactiveInterfaces; //!< flag to indicate whether signals coming from inactive
+                                          //!< spectrum PHY interfaces are tracked during the test
+
+    std::vector<SpectrumChannelInfos> m_spectrumChannelInfos;    //!< Spectrum channels infos
+    std::vector<Ptr<ExtSpectrumWifiPhy>> m_txPhys{};             //!< TX PHYs
+    std::vector<Ptr<ExtSpectrumWifiPhy>> m_rxPhys{};             //!< RX PHYs
+    std::vector<std::unique_ptr<TestPhyListener>> m_listeners{}; //!< listeners
+
+    std::vector<uint32_t> m_counts{0}; //!< count number of packets received by PHYs
+
+    Time m_lastTxStart{0}; //!< hold the time at which the last transmission started
+    Time m_lastTxEnd{0};   //!< hold the time at which the last transmission ended
+};
+
+SpectrumWifiPhyMultipleInterfacesTest::SpectrumWifiPhyMultipleInterfacesTest(
+    bool trackSignalsInactiveInterfaces)
+    : TestCase{"SpectrumWifiPhy test operation with multiple RF interfaces"},
+      m_trackSignalsInactiveInterfaces{trackSignalsInactiveInterfaces}
+{
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel(std::size_t index,
+                                                     WifiPhyBand band,
+                                                     uint8_t channelNumber,
+                                                     uint16_t channelWidth)
+{
+    NS_LOG_FUNCTION(this << index << band << +channelNumber << channelWidth);
+    auto& listener = m_listeners.at(index);
+    listener->m_notifyMaybeCcaBusyStart = 0;
+    listener->m_ccaBusyStart = Seconds(0);
+    listener->m_ccaBusyEnd = Seconds(0);
+    auto phy = m_rxPhys.at(index);
+    phy->SetOperatingChannel(WifiPhy::ChannelTuple{channelNumber, channelWidth, band, 0});
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::SendPpdu(Ptr<SpectrumWifiPhy> phy, double txPowerDbm)
+{
+    NS_LOG_FUNCTION(this << phy << txPowerDbm << phy->GetCurrentFrequencyRange()
+                         << phy->GetChannelWidth() << phy->GetChannelNumber());
+
+    WifiTxVector txVector =
+        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false, false);
+    Ptr<Packet> pkt = Create<Packet>(1000);
+    WifiMacHeader hdr;
+    hdr.SetType(WIFI_MAC_QOSDATA);
+    hdr.SetQosTid(0);
+    hdr.SetAddr1(Mac48Address("00:00:00:00:00:01"));
+    hdr.SetSequenceNumber(1);
+    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+
+    m_lastTxStart = Simulator::Now();
+    m_lastTxEnd = m_lastTxStart + WifiPhy::CalculateTxDuration({std::make_pair(SU_STA_ID, psdu)},
+                                                               txVector,
+                                                               phy->GetPhyBand());
+    phy->SetTxPowerStart(txPowerDbm);
+    phy->SetTxPowerEnd(txPowerDbm);
+    phy->Send(WifiConstPsduMap({std::make_pair(SU_STA_ID, psdu)}), txVector);
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::RxCallback(std::size_t index,
+                                                  Ptr<const Packet> /*packet*/,
+                                                  RxPowerWattPerChannelBand /*rxPowersW*/)
+{
+    auto phy = m_rxPhys.at(index);
+    NS_LOG_FUNCTION(this << index << phy->GetCurrentFrequencyRange() << phy->GetChannelWidth()
+                         << phy->GetChannelNumber());
+    m_counts.at(index)++;
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::CheckInterferences(Ptr<ExtSpectrumWifiPhy> phy,
+                                                          const FrequencyRange& freqRange,
+                                                          uint16_t channelWidth,
+                                                          bool interferencesExpected)
+{
+    if ((!m_trackSignalsInactiveInterfaces) && (phy->GetCurrentFrequencyRange() != freqRange))
+    {
+        // ignore since no bands for that range exists in interference helper in that case
+        return;
+    }
+    // This is needed to make sure PHY state will be checked as the last event if a state change
+    // occurred at the exact same time as the check
+    Simulator::ScheduleNow(&SpectrumWifiPhyMultipleInterfacesTest::DoCheckInterferences,
+                           this,
+                           phy,
+                           freqRange,
+                           channelWidth,
+                           interferencesExpected);
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::DoCheckInterferences(Ptr<ExtSpectrumWifiPhy> phy,
+                                                            const FrequencyRange& freqRange,
+                                                            uint16_t channelWidth,
+                                                            bool interferencesExpected)
+{
+    NS_LOG_FUNCTION(this << phy << freqRange << interferencesExpected);
+    PointerValue ptr;
+    phy->GetAttribute("InterferenceHelper", ptr);
+    auto interferenceHelper = DynamicCast<InterferenceHelper>(ptr.Get<InterferenceHelper>());
+    NS_ASSERT(interferenceHelper);
+    const auto band = phy->GetBandForInterface(channelWidth, 0, freqRange, channelWidth);
+    const auto energyDuration = interferenceHelper->GetEnergyDuration(0, band);
+    NS_TEST_ASSERT_MSG_EQ(energyDuration.IsStrictlyPositive(),
+                          interferencesExpected,
+                          "Incorrect interferences detection");
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::CheckResults(
+    std::size_t index,
+    uint32_t expectedNumRx,
+    FrequencyRange expectedFrequencyRangeActiveRfInterface,
+    const std::vector<std::size_t>& expectedConnectedPhysPerChannel)
+{
+    NS_LOG_FUNCTION(this << index << expectedNumRx << expectedFrequencyRangeActiveRfInterface);
+    const auto phy = m_rxPhys.at(index);
+    std::size_t numActiveInterfaces = 0;
+    for (const auto& [freqRange, interface] : phy->GetSpectrumPhyInterfaces())
+    {
+        const auto expectedActive = (freqRange == expectedFrequencyRangeActiveRfInterface);
+        const auto isActive = (interface == phy->GetCurrentSpectrumPhyInterface());
+        NS_TEST_ASSERT_MSG_EQ(isActive, expectedActive, "Incorrect active interface");
+        if (isActive)
+        {
+            numActiveInterfaces++;
+        }
+    }
+    NS_TEST_ASSERT_MSG_EQ(numActiveInterfaces, 1, "There should always be one active interface");
+    NS_ASSERT(expectedConnectedPhysPerChannel.size() == m_spectrumChannelInfos.size());
+    for (std::size_t i = 0; i < m_spectrumChannelInfos.size(); ++i)
+    {
+        const auto spectrumChannel = std::get<0>(m_spectrumChannelInfos.at(i));
+        NS_TEST_ASSERT_MSG_EQ(spectrumChannel->GetNDevices(),
+                              expectedConnectedPhysPerChannel.at(i),
+                              "Incorrect number of PHYs attached to the spectrum channel");
+    }
+    NS_TEST_ASSERT_MSG_EQ(m_counts.at(index),
+                          expectedNumRx,
+                          "Didn't receive right number of packets");
+    NS_TEST_ASSERT_MSG_EQ(m_listeners.at(index)->m_notifyRxStart,
+                          expectedNumRx,
+                          "Didn't receive NotifyRxStart");
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::CheckCcaIndication(std::size_t index,
+                                                          bool expectedCcaBusyIndication,
+                                                          Time switchingDelay)
+{
+    const auto expectedCcaBusyStart =
+        expectedCcaBusyIndication ? m_lastTxStart + switchingDelay : Seconds(0);
+    const auto expectedCcaBusyEnd = expectedCcaBusyIndication ? m_lastTxEnd : Seconds(0);
+    NS_LOG_FUNCTION(this << index << expectedCcaBusyIndication << expectedCcaBusyStart
+                         << expectedCcaBusyEnd);
+    auto& listener = m_listeners.at(index);
+    const auto ccaBusyIndication = (listener->m_notifyMaybeCcaBusyStart > 0);
+    const auto ccaBusyStart = listener->m_ccaBusyStart;
+    const auto ccaBusyEnd = listener->m_ccaBusyEnd;
+    NS_TEST_ASSERT_MSG_EQ(ccaBusyIndication,
+                          expectedCcaBusyIndication,
+                          "CCA busy indication check failed");
+    NS_TEST_ASSERT_MSG_EQ(ccaBusyStart, expectedCcaBusyStart, "CCA busy start mismatch");
+    NS_TEST_ASSERT_MSG_EQ(ccaBusyEnd, expectedCcaBusyEnd, "CCA busy end mismatch");
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::Reset()
+{
+    NS_LOG_FUNCTION(this);
+    for (auto& count : m_counts)
+    {
+        count = 0;
+    }
+    for (auto& listener : m_listeners)
+    {
+        listener->Reset();
+    }
+    // restore all RX PHYs to initial channels
+    for (std::size_t rxPhyIndex = 0; rxPhyIndex < m_rxPhys.size(); ++rxPhyIndex)
+    {
+        auto txPhy = m_txPhys.at(rxPhyIndex);
+        SwitchChannel(rxPhyIndex,
+                      txPhy->GetPhyBand(),
+                      txPhy->GetChannelNumber(),
+                      txPhy->GetChannelWidth());
+    }
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::DoSetup()
+{
+    NS_LOG_FUNCTION(this);
+
+    // WifiHelper::EnableLogComponents();
+    // LogComponentEnable("SpectrumWifiPhyTest", LOG_LEVEL_ALL);
+
+    const std::vector<std::pair<WifiPhyBand, uint8_t>> channels{{WIFI_PHY_BAND_2_4GHZ, 2},
+                                                                {WIFI_PHY_BAND_5GHZ, 42},
+                                                                {WIFI_PHY_BAND_5GHZ, 114},
+                                                                {WIFI_PHY_BAND_6GHZ, 215}};
+
+    // create spectrum channels
+    for (std::size_t i = 0; i < channels.size(); ++i)
+    {
+        auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+        [[maybe_unused]] const auto [channel, frequency, channelWidth, type, band] =
+            (*WifiPhyOperatingChannel::FindFirst(channels.at(i).second,
+                                                 0,
+                                                 0,
+                                                 WIFI_STANDARD_80211ax,
+                                                 channels.at(i).first));
+
+        m_spectrumChannelInfos.emplace_back(spectrumChannel, frequency, channelWidth);
+    }
+
+    // create PHYs and add all channels to each of them
+    for (std::size_t i = 0; i < channels.size(); ++i)
+    {
+        auto txNode = CreateObject<Node>();
+        auto txDev = CreateObject<WifiNetDevice>();
+        auto txPhy = CreateObject<ExtSpectrumWifiPhy>();
+        txPhy->SetAttribute("ChannelSwitchDelay", TimeValue(Seconds(0)));
+        txPhy->SetAttribute("TrackSignalsFromInactiveInterfaces",
+                            BooleanValue(m_trackSignalsInactiveInterfaces));
+        auto txInterferenceHelper = CreateObject<InterferenceHelper>();
+        txPhy->SetInterferenceHelper(txInterferenceHelper);
+        auto txError = CreateObject<NistErrorRateModel>();
+        txPhy->SetErrorRateModel(txError);
+        txPhy->SetDevice(txDev);
+        for (const auto& [spectrumChannel, freq, width] : m_spectrumChannelInfos)
+        {
+            const uint16_t minFreq = freq - width / 2;
+            const uint16_t maxFreq = freq + width / 2;
+            txPhy->AddChannel(spectrumChannel, {minFreq, maxFreq});
+        }
+        txPhy->SetOperatingChannel(
+            WifiPhy::ChannelTuple{channels.at(i).second, 0, channels.at(i).first, 0});
+        txPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
+        txDev->SetPhy(txPhy);
+        txNode->AddDevice(txDev);
+
+        m_txPhys.push_back(txPhy);
+
+        auto rxNode = CreateObject<Node>();
+        auto rxDev = CreateObject<WifiNetDevice>();
+        auto rxPhy = CreateObject<ExtSpectrumWifiPhy>();
+        rxPhy->SetAttribute("ChannelSwitchDelay", TimeValue(Seconds(0)));
+        rxPhy->SetAttribute("TrackSignalsFromInactiveInterfaces",
+                            BooleanValue(m_trackSignalsInactiveInterfaces));
+        auto rxInterferenceHelper = CreateObject<InterferenceHelper>();
+        rxPhy->SetInterferenceHelper(rxInterferenceHelper);
+        auto rxError = CreateObject<NistErrorRateModel>();
+        rxPhy->SetErrorRateModel(rxError);
+        rxPhy->SetDevice(rxDev);
+        for (const auto& [spectrumChannel, freq, width] : m_spectrumChannelInfos)
+        {
+            const uint16_t minFreq = freq - width / 2;
+            const uint16_t maxFreq = freq + width / 2;
+            rxPhy->AddChannel(spectrumChannel, {minFreq, maxFreq});
+        }
+        rxPhy->SetOperatingChannel(
+            WifiPhy::ChannelTuple{channels.at(i).second, 0, channels.at(i).first, 0});
+        rxPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
+        rxDev->SetPhy(rxPhy);
+        rxNode->AddDevice(rxDev);
+
+        const auto index = m_rxPhys.size();
+        rxPhy->TraceConnectWithoutContext(
+            "PhyRxBegin",
+            MakeCallback(&SpectrumWifiPhyMultipleInterfacesTest::RxCallback, this).Bind(index));
+
+        auto listener = std::make_unique<TestPhyListener>();
+        rxPhy->RegisterListener(listener.get());
+        m_listeners.push_back(std::move(listener));
+
+        m_rxPhys.push_back(rxPhy);
+        m_counts.push_back(0);
+    }
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::DoTeardown()
+{
+    NS_LOG_FUNCTION(this);
+    for (auto& phy : m_txPhys)
+    {
+        phy->Dispose();
+        phy = nullptr;
+    }
+    for (auto& phy : m_rxPhys)
+    {
+        phy->Dispose();
+        phy = nullptr;
+    }
+    Simulator::Destroy();
+}
+
+void
+SpectrumWifiPhyMultipleInterfacesTest::DoRun()
+{
+    NS_LOG_FUNCTION(this);
+
+    const auto ccaEdThresholdDbm = -62.0; ///< CCA-ED threshold in dBm
+    const auto txAfterChannelSwitchDelay =
+        Seconds(0.25); ///< delay in seconds between channel switch is triggered and a transmission
+                       ///< gets started
+    const auto checkResultsDelay =
+        Seconds(0.5); ///< delay in seconds between start of test and moment results are verified
+    const auto flushResultsDelay =
+        Seconds(0.9); ///< delay in seconds between start of test and moment results are flushed
+    const auto txOngoingAfterTxStartedDelay =
+        MicroSeconds(50); ///< delay in microseconds between a transmission has started and a point
+                          ///< in time the transmission is ongoing
+
+    Time delay{0};
+    // make sure all interfaces got active once for all RX PHYs to have them monitored
+    for (std::size_t rxPhyIndex = 0; rxPhyIndex < m_rxPhys.size(); ++rxPhyIndex)
+    {
+        for (std::size_t txPhyIndex = 0; txPhyIndex < m_txPhys.size(); ++txPhyIndex)
+        {
+            if (txPhyIndex == rxPhyIndex)
+            {
+                // handled at end
+                continue;
+            }
+            auto txPhy = m_txPhys.at(txPhyIndex);
+            Simulator::Schedule(delay + Seconds((rxPhyIndex + rxPhyIndex) * 0.1),
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                rxPhyIndex,
+                                txPhy->GetPhyBand(),
+                                txPhy->GetChannelNumber(),
+                                txPhy->GetChannelWidth());
+        }
+        Simulator::Schedule(delay + flushResultsDelay,
+                            &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                            this);
+    }
+
+    // default channels active for all PHYs: each PHY only receives from its associated TX
+    std::vector<std::size_t> expectedConnectedPhysPerChannel =
+        m_trackSignalsInactiveInterfaces ? std::vector<std::size_t>{5, 5, 5, 5}
+                                         : // all RX PHYs keep all channels active when tracking
+                                           // interferences on inactive interfaces
+            std::vector<std::size_t>{2, 2, 2, 2}; // default channels active for all PHYs: each PHY
+                                                  // only receives from its associated TX
+    for (std::size_t i = 0; i < 4; ++i)
+    {
+        auto txPpduPhy = m_txPhys.at(i);
+        delay += Seconds(1);
+        Simulator::Schedule(delay,
+                            &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                            this,
+                            txPpduPhy,
+                            0);
+        for (std::size_t j = 0; j < 4; ++j)
+        {
+            auto txPhy = m_txPhys.at(j);
+            auto rxPhy = m_rxPhys.at(j);
+            const uint16_t minExpectedFreq = txPhy->GetFrequency() - (txPhy->GetChannelWidth() / 2);
+            const uint16_t maxExpectedFreq = txPhy->GetFrequency() + (txPhy->GetChannelWidth() / 2);
+            const FrequencyRange expectedFreqRange = {minExpectedFreq, maxExpectedFreq};
+            Simulator::Schedule(delay + txOngoingAfterTxStartedDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::CheckInterferences,
+                                this,
+                                rxPhy,
+                                txPpduPhy->GetCurrentFrequencyRange(),
+                                txPpduPhy->GetChannelWidth(),
+                                true);
+            Simulator::Schedule(delay + checkResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::CheckResults,
+                                this,
+                                j,
+                                (i == j) ? 1 : 0,
+                                expectedFreqRange,
+                                expectedConnectedPhysPerChannel);
+            Simulator::Schedule(delay + flushResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                                this);
+        }
+    }
+
+    // same channel active for all PHYs: all PHYs receive from TX
+    for (std::size_t i = 0; i < 4; ++i)
+    {
+        delay += Seconds(1);
+        auto txPpduPhy = m_txPhys.at(i);
+        Simulator::Schedule(delay + txAfterChannelSwitchDelay,
+                            &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                            this,
+                            txPpduPhy,
+                            0);
+        const uint16_t minExpectedFreq =
+            txPpduPhy->GetFrequency() - (txPpduPhy->GetChannelWidth() / 2);
+        const uint16_t maxExpectedFreq =
+            txPpduPhy->GetFrequency() + (txPpduPhy->GetChannelWidth() / 2);
+        const FrequencyRange expectedFreqRange = {minExpectedFreq, maxExpectedFreq};
+        for (std::size_t j = 0; j < 4; ++j)
+        {
+            if (!m_trackSignalsInactiveInterfaces)
+            {
+                for (std::size_t k = 0; k < expectedConnectedPhysPerChannel.size(); ++k)
+                {
+                    expectedConnectedPhysPerChannel.at(k) = (k == i) ? 5 : 1;
+                }
+            }
+            auto rxPhy = m_rxPhys.at(j);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                j,
+                                txPpduPhy->GetPhyBand(),
+                                txPpduPhy->GetChannelNumber(),
+                                txPpduPhy->GetChannelWidth());
+            Simulator::Schedule(delay + txAfterChannelSwitchDelay + txOngoingAfterTxStartedDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::CheckInterferences,
+                                this,
+                                rxPhy,
+                                txPpduPhy->GetCurrentFrequencyRange(),
+                                txPpduPhy->GetChannelWidth(),
+                                true);
+            Simulator::Schedule(delay + checkResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::CheckResults,
+                                this,
+                                j,
+                                1,
+                                expectedFreqRange,
+                                expectedConnectedPhysPerChannel);
+            Simulator::Schedule(delay + flushResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                                this);
+        }
+    }
+
+    // Switch all PHYs to channel 36: all PHYs switch to the second spectrum channel
+    // since second spectrum channel is 42 (80 MHz) and hence covers channel 36 (20 MHz)
+    const auto secondSpectrumChannelIndex = 1;
+    auto channel36TxPhy = m_txPhys.at(secondSpectrumChannelIndex);
+    const uint16_t minExpectedFreq =
+        channel36TxPhy->GetFrequency() - (channel36TxPhy->GetChannelWidth() / 2);
+    const uint16_t maxExpectedFreq =
+        channel36TxPhy->GetFrequency() + (channel36TxPhy->GetChannelWidth() / 2);
+    FrequencyRange expectedFreqRange = {minExpectedFreq, maxExpectedFreq};
+    for (std::size_t i = 0; i < 4; ++i)
+    {
+        delay += Seconds(1);
+        auto txPpduPhy = m_txPhys.at(i);
+        Simulator::Schedule(delay + txAfterChannelSwitchDelay,
+                            &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                            this,
+                            txPpduPhy,
+                            0);
+        for (std::size_t j = 0; j < 4; ++j)
+        {
+            if (!m_trackSignalsInactiveInterfaces)
+            {
+                for (std::size_t k = 0; k < expectedConnectedPhysPerChannel.size(); ++k)
+                {
+                    expectedConnectedPhysPerChannel.at(k) =
+                        (k == secondSpectrumChannelIndex) ? 5 : 1;
+                }
+            }
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                j,
+                                WIFI_PHY_BAND_5GHZ,
+                                CHANNEL_NUMBER,
+                                CHANNEL_WIDTH);
+            Simulator::Schedule(delay + checkResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::CheckResults,
+                                this,
+                                j,
+                                (i == secondSpectrumChannelIndex) ? 1 : 0,
+                                expectedFreqRange,
+                                expectedConnectedPhysPerChannel);
+            Simulator::Schedule(delay + flushResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                                this);
+        }
+    }
+
+    // verify CCA indication when switching to a channel with an ongoing transmission
+    for (const auto txPowerDbm : {-60.0 /* above CCA-ED */, -70.0 /* below CCA-ED */})
+    {
+        for (std::size_t i = 0; i < 4; ++i)
+        {
+            for (std::size_t j = 0; j < 4; ++j)
+            {
+                auto txPpduPhy = m_txPhys.at(i);
+                const auto startChannel =
+                    WifiPhyOperatingChannel::FindFirst(txPpduPhy->GetPrimaryChannelNumber(20),
+                                                       0,
+                                                       20,
+                                                       WIFI_STANDARD_80211ax,
+                                                       txPpduPhy->GetPhyBand());
+                for (uint16_t bw = txPpduPhy->GetChannelWidth(); bw >= 20; bw /= 2)
+                {
+                    [[maybe_unused]] const auto [channel, frequency, channelWidth, type, band] =
+                        (*WifiPhyOperatingChannel::FindFirst(0,
+                                                             0,
+                                                             bw,
+                                                             WIFI_STANDARD_80211ax,
+                                                             txPpduPhy->GetPhyBand(),
+                                                             startChannel));
+                    delay += Seconds(1);
+                    Simulator::Schedule(delay,
+                                        &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                        this,
+                                        txPpduPhy,
+                                        txPowerDbm);
+                    Simulator::Schedule(delay + txOngoingAfterTxStartedDelay,
+                                        &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                        this,
+                                        j,
+                                        band,
+                                        channel,
+                                        channelWidth);
+                    for (std::size_t k = 0; k < 4; ++k)
+                    {
+                        Simulator::Schedule(delay + flushResultsDelay,
+                                            &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                                            this);
+                        if ((i != j) && (k == i))
+                        {
+                            continue;
+                        }
+                        const auto expectCcaBusyIndication =
+                            (k == i) ? (txPowerDbm >= ccaEdThresholdDbm)
+                                     : (m_trackSignalsInactiveInterfaces
+                                            ? ((txPowerDbm >= ccaEdThresholdDbm) ? (j == k) : false)
+                                            : false);
+                        Simulator::Schedule(
+                            delay + checkResultsDelay,
+                            &SpectrumWifiPhyMultipleInterfacesTest::CheckCcaIndication,
+                            this,
+                            k,
+                            expectCcaBusyIndication,
+                            txOngoingAfterTxStartedDelay);
+                    }
+                }
+            }
+        }
+    }
+
+    Simulator::Run();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Spectrum Wifi Phy Test Suite
  */
 class SpectrumWifiPhyTestSuite : public TestSuite
